SystemOrganization addCategory: #JSONExtensions!

Json subclass: #OrderedJson
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JSONExtensions'!

!OrderedJson methodsFor: 'private' stamp: 'sebastiansastre 4/22/2012 18:33'!
readDictionary
	| m k v needComma |
	m := OrderedJsonObject new.
	needComma := false.
	[
		self skipWhitespace.
		(stream peekFor: $}) ifTrue: [ ^ m].
		needComma
			ifTrue: [ (stream peekFor: $,) ifFalse: [JsonSyntaxError signal: 'Missing comma'].
					self skipWhitespace]
			ifFalse: [needComma := true].
"		k := self readAny. "
		(stream peekFor: $") ifFalse: [JsonSyntaxError signal: 'Key in dictionary must be string'].
		k := self readString.
		self skipWhitespace.
		(stream peekFor: $:) ifFalse: [JsonSyntaxError signal: 'Missing colon'].
		v := self readAny.
		m at: k put: v.
	] repeat.
! !

!Date methodsFor: '*jsonextensions' stamp: 'paulwilke 1/25/2013 20:28'!
jsonWriteOn: aStream

	aStream 
		nextPut: $";
		nextPutAll: self yyyymmdd printString;
		nextPut: $"! !

!DateAndTime methodsFor: '*jsonextensions' stamp: 'sebastiansastre 3/18/2012 20:22'!
jsonWriteOn: aStream

	aStream 
		nextPut: $";
		nextPutAll: self asUTC printString;
		nextPut: $"! !

OrderedIdentityDictionary subclass: #OrderedJsonObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JSONExtensions'!

!OrderedJsonObject methodsFor: 'actions' stamp: 'sebastiansastre 12/8/2012 16:37'!
asJsonObject

	^ self! !

!OrderedJsonObject methodsFor: 'accessing' stamp: 'sebastiansastre 4/22/2012 18:36'!
at: aKey

	"make it work more like javascript objects"
	^ self at: aKey ifAbsent: [nil]! !

!OrderedJsonObject methodsFor: 'actions' stamp: 'sebastiansastre 4/22/2012 18:36'!
doesNotUnderstand: aMessage
	| key |
	key := aMessage selector.
	key isUnary ifTrue: [^ self at: key ifAbsent: [nil]].
	^ (key isKeyword and: [(key occurrencesOf: $:) = 1])
		ifTrue: [key := key allButLast asSymbol.
				self at: key put: aMessage arguments first]
		ifFalse: [super doesNotUnderstand: aMessage]
				
	! !

!OrderedJsonObject methodsFor: 'accessing' stamp: 'sebastiansastre 4/22/2012 18:36'!
name
"override 'cause Object defines this"
	^self at: 'name'! !

!OrderedJsonObject methodsFor: 'accessing' stamp: 'sebastiansastre 4/22/2012 18:36'!
value
"override 'cause Object defines this"
	^self at: 'value'! !
